//<c>   Copyright 1994-2000 by Gerry J. Danen; all rights reserved.

//<t>   Check for Empty Directories

#include"gd_tools.h"
#include"gd_extrn.h"
#include<direct.h>


#define pgVERS_ "V2.00"
#define pgTITL_ "Check for Empty Directories"
#define pgCOPR_ "1994"


BOOL    ynProcessMultipleDrives = TRUE ;
UCHAR   work[FS_LEN] ;                          // work area
UCHAR   sToFind[FS_LEN] ;                       // file spec to search for
UCHAR   fSpec[FS_LEN*5] ;                       // file spec found
char    origdir[FS_LEN] ;


//      Prototypes
void    select_drives_to_process(UCHAR drives[],UCHAR sFileSpec[]);
void    process_files(void);


void    test_key( STRING where_are_we )
{
    int         k ;

    if ( kbhit() )                              // was a key pressed?
    {
        while( kbhit() )                        // flush everything first
            getch();
        fprintf( stderr, "\nInterrupted at %s\n"
                         "Press C to continue, or A to abort: ", where_are_we );
        k = 0 ;
        while ( k != 'C' && k != 'A' )
        {
            k = getch();
            k = toupper( k );
        }
        fprintf( stderr, "%c\n", k );
        if ( k == 'A' )
        {
            fprintf( stderr, "ABORTED\a\n" );
            exit( 3 );
        }
        fprintf( stderr, "Continuing\n" );
    }
}


void    select_drives_to_process( UCHAR driveArray[], UCHAR sFileSpec[] )
{
    int         i ;

    _strlwr( sFileSpec );
    if ( sFileSpec[1] != DRIV_SEP_CH )          // no drive included
        return ;
    if ( sFileSpec[0] < 'a' || sFileSpec[0] > 'z' ) // not a drive letter
        return ;
    ynProcessMultipleDrives = FALSE ;
    for ( i = 0 ; i < 26 ; i++ )                // reset drives to search
        driveArray[i] = 0 ;
    driveArray[ sFileSpec[0] - 'a' ] = 1 ;      // just this one
    sFileSpec[0] = sFileSpec[1] = SPACE ;       // remove drive
    st_trim( sFileSpec );
}


void    process_files( void )
/*
        This procedure searches for files that match the sToFind.  Once a
        match is found, its name and other information is printed on the
        screen.  The date and time as well as the path are all displayed.
        This procedure is recursive.
*/
{
    char        curdir[FS_LEN], temp[3] ;
    int         done, attrib ;
    struct find_t dta ;
    BOOL        isRoot, isEmpty ;

    getcwd( curdir, sizeof(curdir) );
    strupr( curdir );

    test_key( curdir );                         // see if we need to abort

    if ( (strlen(curdir) == 3) && (curdir[1] == DRIV_SEP_CH) )
        isRoot = TRUE ;
    else
        isRoot = FALSE ;

    attrib = ALL_FILES ;
    done = _dos_findfirst( sToFind, attrib, &dta );
    if ( done )
    {
        printf( "rd %s\n", curdir );
    }
    else
    {
        isEmpty = TRUE ;
        while ( ! done )
        {
            strncpy( temp, dta.name, 2);
            if ( ! ((dta.attrib & _A_SUBDIR) == _A_SUBDIR) )
            {
                isEmpty = FALSE ;
            }
            else
            {
                if ( temp[0] != '.' )
                    isEmpty = FALSE ;
            }
            done = _dos_findnext( &dta );
        }
        if ( isEmpty )
        {
            strcpy( work, &curdir[strlen(curdir)-11] );
            if ( ! st_eq(work, "deleted.sav") )
                printf( "rmdir %s\n", curdir );
        }
    }

    attrib = _A_SUBDIR+_A_SYSTEM+_A_HIDDEN ;
    done = _dos_findfirst( "*.*", attrib, &dta );

    while ( ! done )
    {
        strncpy( temp, dta.name, 2);
        if ( ((dta.attrib & _A_SUBDIR) == _A_SUBDIR) && (temp[0] != '.') )
        {
            if ( ! isRoot )
                strcat( curdir, "\\" );
            strcat( curdir, dta.name );
            _chdir( curdir );
            process_files();                    // recursive call
            _chdir( ".." );
            getcwd( curdir, sizeof(curdir) );
        }
        done = _dos_findnext( &dta );
    }
}


void    main_exit( void )
{
    unsigned    numofdrives ;

    _dos_setdrive( origdir[0] - 64, &numofdrives );
    _chdir( origdir );                          // back to original
}


void    main( int argc, char *argv[] )
/*
        The main section of this utility does several interesting things.  One
        of these is the creation of a table of valid drives.  It assumes that a
        system can have 26 drives (one per letter of the alphabet) and proceeds
        to check each drive.
*/
{
    UCHAR       availdrvs[26] ;
    char        rootdir[FS_LEN], tempdir[FS_LEN] ;
    unsigned    numofdrives ;
    int         i ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);
    atexit( main_exit );

    if ( argc > 1 )
    {
        ST_CPY( sToFind, argv[1] );
    }
    else
    {
        logon(1);
        fprintf( stderr, "\n\tUsage: %s [d:]\n"
                "\n\tIf [d:] is *, then all drives as per GD.DRIVES are searched\n\n",
                get_global_program_name() );
        exit( BAD_EXIT );
    }

    _getcwd( origdir, sizeof(origdir) );        // get current directory
    ds_avail_drives( availdrvs );
    availdrvs[0] = availdrvs[1] = 0 ;           // bypass a: and b: by default
    select_drives_to_process( availdrvs, sToFind ); // check for drive in filespec

    ST_CPY( sToFind, "*.*" );                   // all files...

    if ( ynProcessMultipleDrives )
    {
        int ndrives = 0 ;

        for ( i = 0 ; i < 26 ; i++ )            // count drives to process
        {
            if ( availdrvs[i] == 1 )
                ndrives += 1 ;
        }
        if ( ndrives > 0 )                      // are there _any_ drives?
        {
            fprintf( stderr, "Checking drive%s:", ndrives==1 ? "" : "s" );
            for ( i = 0 ; i < 26 ; i++ )        // A: to Z:
            {
                if ( availdrvs[i] == 1 )
                {
                    fprintf( stderr, " %c", (char) ('A' + i) );
                }
            }
            fprintf( stderr, "\n" );
        }
    }

    for ( i = 0 ; i < 26 ; i++ )                // A: to Z:
    {
        if ( availdrvs[i] == 1 )
        {
            rootdir[0] = (char) ('A' + i) ;     // form a drive letter
            rootdir[1] = DRIV_SEP_CH ;          //  followed by a colon
            rootdir[2] = PATH_SEP_CH ;          //  and a backslash.
            rootdir[3] = 0 ;
            if ( ynProcessMultipleDrives )
                fprintf( stderr, "\nDrive %c: ", rootdir[0] );
            _dos_setdrive( i+1, &numofdrives );
            _getcwd( tempdir, sizeof(tempdir) );
            _chdir( rootdir );                  // switch to root
            process_files();
            _chdir( tempdir );
        }
    }
    exit( GOOD_EXIT );
}
